// Country5a.h
// This will hold the class definitions for countries
// Copyright (c) 1998 Forest J. Handford
/////////////////////////////////////////////////////

#ifndef Country5a_h
#define Country5a_h

#define MAX_PLAYERS 2
#define TRUE 1
#define FALSE 0

class CCountries
{
private:    
    class CPlayer
    {
        friend CCountries;    // Give CCountries access
        int Armies;
        int Money;
        int Territory;
        int Technology;
        int UpgradeCost;
        
        char Name[15];
        CPlayer()
        {
            Armies = 5;
            Money = 5;
            Territory = 5;
            Technology = 1;
            UpgradeCost = 5;
        }
    public:

        // This will sell land
        void Grow()
        {
            char YorN = 'y';    // For Yes or No answers

            // Loop as long as they want to grow
            for(int Count=0; tolower(YorN) == 'y'; Count++)
            {
                // They most have at least one army for every territory
                if (Armies <= Territory)
                {
                    cout<<"You need more armies for more land."<<endl;
                    break;
                }
                // Sell the land and tell the players
                else if(Money > 0)
                {
                    Money -= 1;
                    Territory += 1;
                    cout<<"You now have "<<Territory
                        <<" States and "<<Money<<" money."<<endl;
                    // Don't stay here if they are out of land or money
                    if((Armies <= Territory) || (Money <= 0))
                    {
                        break;
                    }
                    cout<<"Would you like to buy another (Yes or No)?";
                    cin>>YorN;
                }
                // If they are out of money tell them and exit
                else
                {
                    cout<<"You are out of money!"<<endl;
                    break;
                }
            }

        }

        // This will check for to many territories
        void CountryLoss()
        {
            if(Armies < Territory)
            {
                cout<<"Sorry "<<Name<<", you don't have enough armies to keep "
                    <<"your territories!  They are"
                    <<endl<<"reduced to "<<Armies<<"."
                    <<endl;
                Territory = Armies;
            }
        }
    };


public:
    CPlayer Players[MAX_PLAYERS];
    
    
    void Upgrade(bool Player)
    {
        char YorN = 'y';

        // Loop till the user is out of money or is bored
        while(tolower(YorN) == 'y')
        {
            // Take their money if they have any
            if(Players[Player].Money >= Players[Player].UpgradeCost)
            {
                Players[Player].Money -= Players[Player].UpgradeCost;
                Players[Player].UpgradeCost *= 2;
                Players[Player].Technology += 1;
                cout<<"You now have "<<Players[Player].Technology
                    <<" Upgrades and "<<Players[Player].Money<<" money."<<endl;
                cout<<"Upgrades now cost you : "<<Players[Player].UpgradeCost<<"."<<endl;
            }
            else    // Scold them for having no money
            {
                cout<<"You don't have enough money.  You need "<<Players[Player].UpgradeCost<<"."
                    <<endl;
            }
            // break if they run out of money
            if(Players[Player].Money <= Players[Player].UpgradeCost)
            {
                break;
            }

            // ask if they want more
            cout<<"Would you like to upgrade again (Yes or No)? ";
            cin>>YorN;
        }
    }

    
    void Shrink(bool Player)
    {
        char YorN = 'y';

        while(tolower(YorN) == 'y')
        {
            if(Players[Player].Territory > 0)
            {
                Players[Player].Money += 1;
                Players[Player].Territory -= 1;
                cout<<"You now have "<<Players[Player].Territory
                    <<" States and "<<Players[Player].Money<<" money."<<endl;
                cout<<"Would you like to buy another (YorN)?";
                cin>>YorN;
            }
            else
            {
                cout<<"You are out of money!"<<endl;
                break;
            }
        }
    }

    void AddStuff(bool Player)
    {
        Players[Player].Armies += Players[Player].Territory;
        Players[Player].Money += Players[Player].Territory;
        WriteName(Player);
        cout<<" now has "<<Players[Player].Armies
            <<" armies and "<<Players[Player].Money<<" money from ";
        WriteName(Player);
        cout<<"'s states."<<endl<<endl;
    }
    void WriteName(bool C)
    {
        cout<<Players[C].Name;
    }

    void Dead(bool Victim)
    {
        WriteName(Victim);
        cout<<" you are dead!"<<endl;
        WriteName(Victim == 0 ? 1 : 0);
        cout<<" you have won!"<<endl<<endl;
    }

public:
    CCountries()
    {
        for(int Count = 0; Count < 2; Count ++)
        {
            cout<<"Player "<<Count + 1<<" What is your name? ";
            cin>>Players[Count].Name;
            cout<<endl;
        }

    }

    bool Attack(bool Attacker, bool Victim)
    {
        int AttackerArmies;    //This will hold the attacker's # of armies
        int VictimArmies;    //This will hold the Victim's # of armies
        char YorN = 'Y';

        while(toupper(YorN) == 'Y')
        {
            AttackerArmies = Players[Attacker].Armies - (Players[Victim].Armies * Players[Victim].Technology / Players[Attacker].Armies * Players[Attacker].Technology);
            VictimArmies = Players[Victim].Armies - (Players[Attacker].Armies * Players[Attacker].Technology / Players[Victim].Armies * Players[Victim].Technology);
            Players[Attacker].Armies = AttackerArmies;
            Players[Victim].Armies = VictimArmies;
            
            if(Players[Victim].Armies < 1)
            {
                Dead(Victim);
            }
            
            if(Players[Attacker].Armies < 1)
            {
                Dead(Attacker);
                return FALSE;    // Flag end of Game
            }
            
            if(Players[Victim].Armies < 1)
            {
                return FALSE;    // Flag end of Game
            }
            
            Players[Victim].CountryLoss();
            Players[Attacker].CountryLoss();
            WriteName(Attacker);
            cout<<" now has "<<Players[Attacker].Armies<<" armies."<<endl;
            WriteName(Victim);
            cout<<" now has "<<Players[Victim].Armies<<" armies."<<endl;
            WriteName(Attacker);
            cout<<", Would you like to attack again (Yes or No)? ";
            cin>>YorN;

        }
        return TRUE;    // Flag success
    }
};

#endif
